> For the complete documentation index, see [llms.txt](https://docs.mindstellar.com/osclass-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mindstellar.com/osclass-docs/v3.9.0/developers/plugins-themes/auto-update-themes-and-plugins.md).

# Auto-update themes and plugins

In version 3.0, we introduced an auto-upgrade system for plugins and themes, along with some neat features. To make your plugins and themes able to use this new feature, you need to use the Update URI param on the description of your creations. The Update URI should be unique per theme/plugin and reply a JSON response with the following format:

```php
{
dt_mod_date: "YYYY-MM-DD HH:MM:SS",
dt_pub_date: "YYYY-MM-DD HH:MM:SS",
e_type: "{TYPE}",
i_total_downloads: "XYZ",
s_banner: "banner.jpg",
s_banner_path: "http://www.domain.tld/path/to/banner/",
s_compatible: "2.3,2.4,3.0,3.1,3.1.1,3.1.2",
s_contact_name: "My name",
s_description: "My description, HTML accepted",
s_source_file: "http://www.domain.tld/path/to/my_plugin.zip",
s_title: "Title",
s_update_url: "http://www.domain.tld/path/to/update/cheker.php",
s_version: "A.B.C",
}
```

\
**s\_version**: Any alphanumeric string is ok, but we encourage only-numeric ones to be able to check is a version is greater or not than the installed one, preferred A.B.C style, as "1.0.2" or "2.1.0"

\
**e\_type**: e\_type **has to be** one of these options THEME or PLUGIN or "LANGUAGE"


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.mindstellar.com/osclass-docs/v3.9.0/developers/plugins-themes/auto-update-themes-and-plugins.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
